TalentSwitch = {}

local locked = 0

tLocs = {  { {},{},{},{},{},{},{} }  ,  { {},{},{},{},{},{},{} }  }
tsParseEvocation = false
custom = {  {}  ,  {}  }

local specGroup = GetActiveSpecGroup();

local replacedAbilities = {
				['108194']=47476,	--asphixiate
				['102355']=770,		--faerie swarm
				['109260']=13165,	--aspect of the iron hawk
				['110959']=66,		--greater invisibility
				['116011']=12051,	--rune of power
				['115008']=109132,	--chi torpedo
				['116847']=101546,	--rushing jade wind
				['114163']=85673,	--eternal flame
				['105593']=853,		--fist of justice
				['123040']=34433,	--mindbender
				['129250']=14914,	--power word: solace
				['114014']=121733,	--shuriken toss
				['51485']=2484,		--earthgrab totem
				['103840']=34428,	--impending victory
				['114029']=3411		--safeguard 

			  }

-- slash command
SLASH_TSWITCH1 = '/tswitch';
SLASH_TSWITCHJARMODE1 = '/tswitch_jar';
SLASH_TSWITCHCUSTOM1 = '/tswitchadd';
SLASH_TSWITCHLIST1 = '/tswitchlist';
SLASH_TSWITCHDEL1 = '/tswitchdel';
SLASH_TSWITCHTUT1 = '/tswitchhelp';

function SlashCmdList.TSWITCH(msg, editbox)
	if msg ~= "commands" then
		TSwitchUIframe:Show{}

		local name, realm = UnitName("player")
		if name == "Jarjour" or name == "Karaashi" then
			print("/tswitch_jar - activate Jarjours special mage mode! (This function is now deprecated, but left in for your convenience)")
		end

		return
	end

	print("Command list:\n/tswitchadd - add custom parse rules (see tutorial)\n/tswitchlist - view custom parse rules\n/tswitchdel - delete specified custom parse rule\n/tswitchhelp - display the tutorial/help file.")
end

-- deprecated function for Jarjour!
function SlashCmdList.TSWITCHJARMODE(msg, editbox)

	if msg ~= 'check' then
		tsParseEvocation = not tsParseEvocation 
	end

	if tsParseEvocation == true then
		print("Parsing macros for Evocation if Invocation is selected.")
		TalentSwitch.doMacros()
	else
		print("NOT parsing macros for Evocation if Invocation is selected.")
	end
end

-- event handlers
local function OnWrongEvent(self, event, ...)
	locked = 2 --this thing is to prevent the addon working when talents arent changed, your spec is
end

local function OnMacroChange(self, event, ...)	
	TalentSwitch.doMacros()
end

local function OnEvent(self, event, ...)
	self:UnregisterEvent("PLAYER_REGEN_ENABLED")
	if InCombatLockdown() then --you never know !
		self:RegisterEvent("PLAYER_REGEN_ENABLED")
		return
	end

	 -- if they just changed spec, don't process talents despite the API event
	local checkSpecGroup = GetActiveSpecGroup();
	if checkSpecGroup ~= specGroup then
		specGroup = checkSpecGroup 
		return
	end

	--the API will fire 1 or 2 talent change events we need to ignore just after a talent switch that aren't stopped above
	--assuming 2 will fire is OK, since theres a redundant event when we want to do this for real which will eat up any extra lock
	if locked > 0 then 
		locked = locked -1
	else
		TalentSwitch.doBars()
	end

	-- parse macros no matter what though
	TalentSwitch.doMacros()	
end


-- functions
function TalentSwitch.doMacros()


	local talents = {}
	local active = {}	

	for i = 1, 7 do
		talents[i] = {}
	end


	for i = 1, 7 do
	for i2 = 1,3 do
		local spellID, name, iconTexture, selected, available = GetTalentInfo(i,i2,specGroup)

		if i ~= nil and i <= 7 and i >= 0 then
			table.insert(talents[i], name)
		else
			print(GetTalentInfo(i,i2,specGroup))
		end

		if selected then
			active[i] = name
		end
	end
	end


	local general, character = GetNumMacros()
	character = character + 120
	
	for j = 1, general do
		TalentSwitch.sub(j, talents, active)
	end

	for j = 37,  character do
		TalentSwitch.sub(j, talents, active)
	end

end

function TalentSwitch.sub(j, talents, active)

	local tiers = 7
	local name, tex, body, flag = GetMacroInfo(j)

	if body ~= nil then
		local bbody = body --so we only update macros if theres an actual change we need a backup to compare to

		for i = 1, tiers do
			if active[i] ~= nil then
				
				for k = 1, 3 do
					if talents[i][k] ~= active[i] then
		
					local out_str = TalentSwitch.esc(talents[i][k])
					local in_str = TalentSwitch.esc(active[i])
	
	-- evocation options
						if talents[i][k] == "Invocation" and tsParseEvocation==true then
							body=body:gsub("Evocation", in_str)
						elseif active[i] == "Invocation" and tsParseEvocation==true then
							body=body:gsub(out_str, "Evocation")
	-- everything else
							else
							body=TalentSwitch.rev_custom(active[i], talents[i][k], body) -- reverse custom mappings
							body=body:gsub(out_str, in_str) -- switch talent names to the new talent
						end
	
					end
				end
	
				body=TalentSwitch.do_custom(active[i], body) -- and activate the new talent's mappings
			end
		end

		if bbody ~= body then --only if the macro has actually changed
			if string.len(body) < 256 then
				EditMacro(j, nil, nil, body)
			else
				print("TalentSwitch - ERROR: could not update macro "..name.." due to length constraints. ("..string.len(body).."/255)")
			end
		end
	end
end

function TalentSwitch.doBars()

	local talents = {}
	for i = 1, 7 do
		talents[i] = {}
	end
	local active = {}

	local specGroup = GetActiveSpecGroup(); 

	--Glyph of Harsh Words
	do_palacheck()

	for i = 1, 7 do
	for i2 = 1,3 do
		local spellID, name, iconTexture, selected, available = GetTalentInfo(i,i2,specGroup)

		if name and spellID then
			if selected then
				active[i] = spellID
			else
				table.insert(talents[i], name)
			end
		end
	end
	end
	

	for i = 1, 120 do
		local type, id, subtype = GetActionInfo(i)
		local name = GetSpellInfo(id)

		if type ~= "macro" and type ~= nil then
			for j = 1, 7 do

				if id ~= nil and tLocs[specGroup][j][i] ~= id and tLocs[specGroup][j][i] ~= nil then -- if a saved slot now has a skill on it, we can no longer use it
					tLocs[specGroup][j][i] = nil
				end

				if ( active[j] ~= nil and id ~= nil and (name == talents[j][1] or name == talents[j][2] or tLocs[specGroup][j][i] == id)) then

					local passive = IsPassiveSpell(active[j])
					
					if passive == nil then
						PickupAction(i)
						ClearCursor()
						PickupSpell(active[j])
						PlaceAction(i)

						name2 = GetSpellInfo(active[j])

						tLocs[specGroup][j][i] = replacedAbilities[active[j]]

						print("Replaced "..name.." with "..tostring(name2).." on button "..i..".")
					else
						PickupAction(i)
						ClearCursor()
						tLocs[specGroup][j][i] = true
						print("Passive talent selected, remembering that "..name.." was removed from button "..i..".")
					end
					break										-- no need to check further tiers if we match
				end
			end
		end

		if type == nil then -- check empty slots to see if they were saved for talents
			for j = 1, 7 do
				if tLocs[specGroup][j][i] ~= nil and active[j] ~= nil then
					
					local passive = IsPassiveSpell(active[j])
					
					if passive == nil then
						PickupSpell(active[j])
						PlaceAction(i)

						name2 = GetSpellInfo(active[j])

						print("Placed "..name2.." on button "..i..".")
						tLocs[specGroup][j][i] = nil
					end
					break	
				end
			end
		end

	end

	ClearCursor()
--	print("Flashing")
--	TalentSwitch.doFlash()

end

function do_palacheck()
	if select(2, UnitClass("player")) ~= "PALADIN" then
   		return
	end

	local specGroup = GetActiveSpecGroup(); 

	for i = 1, NUM_GLYPH_SLOTS do
		local enabled, glyphType, glyphTooltipIndex, glyphSpellID, icon = GetGlyphSocketInfo(i);

		if glyphSpellID == 54938 then--Glyph of Harsh Words
			for j=1,120 do
				if tLocs[specGroup][3][j] == 85673 then
					tLocs[specGroup][3][j] = 136494
				end
			end
			return
		end
	end

	for i=1,120 do
		if tLocs[specGroup][3][i] == 136494 then
			tLocs[specGroup][3][i] = 85673
		end
	end
	
end

function OnGlyphChanged()

	-- this is a bit of a hack to fix the a deafult UI issue
	-- macro tooltips on Guard when switching between the glyphed/unglyphed versions don't normally update, which can
	-- cause greyed out Guard icons even when it is available for use. This forces an update.
	if select(2, UnitClass("player")) == "MONK" then

		local general, character = GetNumMacros()
		character = character + 36
		
		for j = 37,  character do
			local name, tex, body, flag = GetMacroInfo(j)

			if body:find("guard") ~= nil or body:find("Guard") ~= nil then
				EditMacro(j, nil, nil, "#showtooltip guard ")
				EditMacro(j, nil, nil, body)
			end
		end
	end
print ("fixed macro issue")
end

function OnLoaded(self, event, ...)
	arg1 = select(1,...)
	if arg1 =="TalentSwitch" then
		print("TSwitch loaded")
		
		if tLocs[1][7] == nil then
			tLocs[1][7]= {}
		end
		if tLocs[2][7] == nil then
			tLocs[2][7]= {}
		end
	end
end

local frame = CreateFrame("Frame")
frame:SetScript("OnEvent", OnEvent)
frame:RegisterEvent("PLAYER_TALENT_UPDATE")

local frame2 = CreateFrame("Frame")
frame2:SetScript("OnEvent", OnWrongEvent)
frame2:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")

local frame3 = CreateFrame("Frame")
frame3:SetScript("OnEvent", OnMacroChange)
frame3:RegisterEvent("UPDATE_MACROS")

local frame4 = CreateFrame("Frame")
frame4:SetScript("OnEvent", OnGlyphChanged)
frame4:RegisterEvent("GLYPH_REMOVED")

local frame5 = CreateFrame("Frame")
frame5:SetScript("OnEvent", OnLoaded)
frame5:RegisterEvent("ADDON_LOADED")
